#ifndef __special_functions_H
#define __special_functions_H

#include "complex.hh"

const double PI_DEF =  3.1415926535897932385;
const double PISQ   =  9.86960440108935861883;
const double ZETA2  =  1.64493406684822643647;
const double PISQ6  =  1.64493406684822643647;
const double PI4    = 97.409091034002437236440;
const double ZETA3  =  1.2020569031595942855;
const double ZETA4  =  1.082323233711138191516;
const double ZETA5  =  1.036927755143369926331;
const double EulerGamma = 0.5772156649015328606065120900824;


inline int sign(double x) { return (x>0 ? 1 : -1); }


template<class T>
inline T SQR(T a){return a*a;}


extern dcomplex logGamma(dcomplex z);
extern dcomplex Gamma(dcomplex z);

extern dcomplex  TruncatedGamma(const dcomplex a, const double x);
extern dcomplex IncompleteGamma(const dcomplex a, const double x);
extern dcomplex IncompleteBeta (const dcomplex a, const dcomplex b, const double x);

//extern dcomplex psi0(dcomplex z);
//extern dcomplex psi_n(int n, dcomplex z);




# endif
